; GUI #
include win64a.inc
IDC_DIALOG	equ 200
IDC_TXT		equ 100
ID_ICON		equ 102
IDC_ICON1	equ 500
RPC_S_OK	equ 0
RPC_C_LISTEN_MAX_CALLS_DEFAULT equ 1234
RPC_VERSION  struc
	MajorVersion dw ?
	MinorLinker  dw ?
RPC_VERSION  ends
RPC_SERVER_INTERFACE struct
	Len		dd ?
	InterfaceId	GUID <>
	a		RPC_VERSION <>
	TransferSyntax	GUID <>
	b		RPC_VERSION <>
			dd ?
	DispatchTable	dq ?
	RpcProtseqEndpointCount  dd ?,?
	RpcProtseqEndpoint dq ?
	DefaultManagerEpv dq ?
	InterpreterInfo dq ?
	Flags		dd ?,?
RPC_SERVER_INTERFACE ends

.code
WinMain proc
	enter	30h,0
	mov	r9d,offset DialogProc
	and	qword ptr[rbp-10h],0
        invoke  DialogBoxParamA,IMAGE_BASE,IDC_DIALOG,HWND_DESKTOP
        invoke  RtlExitUserProcess,NULL
WinMain endp
DialogProc proc hWnddlg:qword,msg:qword,wParam:qword,lParam:qword
	mov	hWnddlg,rcx
	mov	lParam,r9

        cmp	edx,WM_INITDIALOG
	je 	wmINITDIALOG
	cmp	edx,WM_CLOSE
	je	wmCLOSE
	cmp	edx,WM_COMMAND
	je	wmCOMMAND
	cmp	edx,WM_DESTROY
	je	wmDESTROY
	xor	eax,eax
	jmp	exit0
wmDESTROY:
	jmp	wmBYE
wmINITDIALOG:mov hWnd,rcx
	invoke	GetProcessHeap
	mov     hHeap,rax	
;   
	mov	edx,offset szWin
        invoke  FindWindowA,NULL
        or      eax,eax
        jnz	wmBYE
	mov	edx,offset Error1
	mov	r8d,offset szAppName
	invoke	MessageBoxA,hWnddlg,,,MB_ICONEXCLAMATION or MB_YESNO
	cmp	eax,IDNO
	jz      wmBYE
	mov	ecx,offset szService
	invoke	WinExec,,SW_SHOW
;start Rpc Server And Listen
	mov	r8d,offset endpoint
	mov	ecx,offset protocol
	invoke	RpcServerUseProtseqEpA,,RPC_C_LISTEN_MAX_CALLS_DEFAULT,,0
	or	eax,eax;cmp	eax,RPC_S_OK
	jz	@f
	mov	edx,offset Format
	jmp	@0
@@:	mov	ecx,offset RPC_SampleInterface_v1_0_s_ifspec
	invoke	RpcServerRegisterIf,,0,0
	or	eax,eax;cmp	eax,RPC_S_OK
	jz	@f
	mov	edx,offset aUnableToRegist
	jmp	@0
; Start to listen for remote procedure
; calls for all registered interfaces.
; This call will not return until
; RpcMgmtStopServerListening is called.
@@:	invoke	RpcServerListen,1,\;Recommended minimum number of threads.
	RPC_C_LISTEN_MAX_CALLS_DEFAULT,\;Recommended maximum number of threads
	TRUE
	or	eax,eax;cmp	eax,RPC_S_OK
	jz	wmBYE
	mov	edx,offset aUnableToStartL
	mov	r8d,offset szAppName
	invoke	MessageBoxA,hWnddlg,,,MB_ICONEXCLAMATION or MB_OK
	mov	ecx,offset RPC_SampleInterface_v1_0_s_ifspec
	invoke	RpcServerUnregisterIf,,0,0
	or	eax,eax;cmp	eax,RPC_S_OK
	jz	wmBYE
	mov	edx,offset aUnableToUnregi
@0:	mov	r8d,offset szAppName
	invoke	MessageBoxA,hWnddlg,,,MB_ICONEXCLAMATION or MB_OK
	jmp	wmBYE
;--------------------------------------------------
wmCOMMAND:cmp	r8d,BN_CLICKED shl 16 + IDCANCEL
	jne	wmBYE
wmCLOSE:invoke	EndDialog,,0
wmBYE:	mov	eax,TRUE
exit0:	leave
	retn
DialogProc endp

j_NdrServerCall2 proc
	jmp	NdrServerCall2
j_NdrServerCall2 endp
; Memory allocation function for RPC.
; The runtime uses these two functions for allocating/deallocating
; enough memory to pass the string to the server.
MIDL_user_allocate proc len:qword
	mov	r8d,ecx
	invoke	RtlAllocateHeap,hHeap,0
	leave
	retn
MIDL_user_allocate endp
MIDL_user_free proc lpMem:qword
	mov	r8d,ecx
	invoke	HeapFree,hHeap,0
	leave
	retn
MIDL_user_free endp
RPC_SampleInterface_sampleFunc proc handle_t:qword,size_:dword,buffer:qword
local	hWaveOut:qword
local	lpwiocb:WAVEHDR

	mov	buffer,r8
	mov	size_,edx
	mov	handle_t,rcx
	cmp	byte ptr[r8],CF_TEXT
	jne	@f
	and	byte ptr[r8+rdx],0
	inc	r8
	invoke	SetDlgItemTextA,hWnd,IDC_TXT;,buffer	
	jmp	@0
;------------------------------------------------------------------
@@:	cmp	byte ptr[r8],CF_BITMAP
	jne	@f
	lea	ecx,[r8+1]
	invoke  CreateIconFromResourceEx,,,TRUE,30000h,256,256,LR_DEFAULTCOLOR
	invoke  SendDlgItemMessageA,hWnd,ID_ICON,STM_SETIMAGE,IMAGE_ICON,eax
	jmp	@0
;------------------------------------------------------------------
@@:	mov	r8,buffer
;"RIFF"+(File size)+(File Type Header)+(Format chunk marker)+(Length of format data) = 14h
        add	r8d,14h
        invoke	waveOutOpen,&hWaveOut,WAVE_MAPPER,,0,0,WAVE_ALLOWSYNC
;    
	lea	edi,lpwiocb
	mov	edx,edi
	xor	eax,eax
	mov	ecx,(sizeof WAVEHDR)/8
	rep	stosq

	mov	rax,buffer
;"RIFF"+(File size)+(File Type Header)+(Format chunk marker)+(Length of format data)+\
;(Type of format)+(Number of Channels)+(Sample Rate)+(Sample Rate*BitsPerSample*Channels/8)+\
;(BitsPerSample*Channels/8)+(Bits per sample)+(data chunk header)+(Size of the data section)=2Ch
	add	rax,2Ch
	mov	[rdx].WAVEHDR.lpData,rax ;  
	mov	eax,size_
	sub	eax,2Ch
	mov	[rdx].WAVEHDR.dwBufferLength,eax ;  
	invoke	waveOutPrepareHeader,hWaveOut,,sizeof WAVEHDR
;   
	invoke	waveOutWrite,hWaveOut,&lpwiocb,sizeof WAVEHDR
@@:	test	lpwiocb.dwFlags,WHDR_DONE
	jz	@b
	invoke	waveOutUnprepareHeader,hWaveOut,&lpwiocb,sizeof WAVEHDR
	invoke	waveOutClose,hWaveOut
@0:	leave			
	retn
RPC_SampleInterface_sampleFunc endp
;-----------------------------------------------------------------------
.data
szWin		db "Remote Procedure Call Sender",0
Error1		db "The server is not running.",10,"Run?",0
szAppName	db "Remote Procedure Call Reciever",0
szService	db "14s",0
protocol	db "ncalrpc",0
endpoint	db "{46E785FC-BCCC-46B8-B161-D6C90D391670}",0; // Unique user-defined endpoint ID in a free form
Format		db "Unable to setup protocol sequence",0
aUnableToRegist	db "Unable to register the interface",0
aUnableToStartL db "Unable to start listening",0
aUnableToUnregi db "Unable to unregister the interface",0
hWnd		dq ?
hHeap		dq ?
; 
RPC_SampleInterface_v1_0_s_ifspec label RPC_SERVER_INTERFACE
	dd sizeof RPC_SERVER_INTERFACE;Length
	GUID <8A4A7813h,0ADAAh,49BCh,{99h,6Ah,4Dh,47h,71h,5Fh,0CAh,40h}>
	RPC_VERSION <1,0>          ;RPC_VERSION  MajorVersion: u16, MinorVersion: u16 +14
	GUID <8A885D04h,1CEBh,11C9h,{9Fh,0E8h,8,0,2Bh,10h,48h,60h}>               ;+20
	RPC_VERSION <2,0>          ;RPC_VERSION  MajorVersion: u16, MinorVersion: u16 +28
	dd 0                                                 ;+2C
	dq RPC_SampleInterface_v1_0_DispatchTable;DispatchTable: *mut RPC_DISPATCH_TABLE +30
	dd 0,0 ;RpcProtseqEndpointCount: u32                 +38
	dq 0   ;RpcProtseqEndpoint: *mut RPC_PROTSEQ_ENDPOINT +3C
	dq 0   ;DefaultManagerEpv: *mut c_void               +44
	dq RPC_SampleInterface_ServerInfo;InterpreterInfo: *const c_void +4C
	dd 4000000h  ;Flags: u32
RPC_SampleInterface_v1_0_DispatchTable:
	dq 1
	dq RPC_SampleInterface_table
	dq 0
RPC_SampleInterface_table:
	dq j_NdrServerCall2
	dq 0
;---------------------------------------------
RPC_SampleInterface_ServerInfo:
		dq RPC_SampleInterface_StubDesc
		dq RPC_SampleInterface_ServerRoutineTable
		dq RPC_SampleInterface__MIDL_ProcFormatString
		dq RPC_SampleInterface_FormatStringOffsetTable
		dq 0
		dq 0
		dq 0
		dq 0
RPC_SampleInterface_StubDesc:
		dq RPC_SampleInterface_v1_0_s_ifspec
		dq MIDL_user_allocate               
		dq MIDL_user_free                   
		dq 0                                
		dq 0                                
		dq 0                                
		dq 0                                
		dq 0                                
		dq RPC_SampleInterface__MIDL_TypeFormatString
		dd 1
		dd 50002h
		dq 0     
		dd 8010274h
		dq 0       
		dq 0       
		dq 0           
		dd 0           
		dq 1           
		dq 0           
		dq 0           
		dq 0           
;------------------------------------------
RPC_SampleInterface_ServerRoutineTable dq RPC_SampleInterface_sampleFunc
RPC_SampleInterface__MIDL_ProcFormatString:
	db 0,48h
	dd 0
	dw 0
	dw 18h
	db 32h,0
	dw 0
	dw 8
	dw 0
	db 42h,2,0Ah,5
	dw 0
	dw 1
	dw 0
	dw 0
	dw 48h
	dw 8
	db 8,0
	dw 10Bh
	dw 10h
	dw 6
	db 0
RPC_SampleInterface_FormatStringOffsetTable:
	dd 0
RPC_SampleInterface__MIDL_TypeFormatString:
	dw 0
	db 11h,0
	dw 2
	db 1Bh,0
	dw 1
	db 29h,0
	dw 8
	dw 1
	db 2,5Bh,0
end 