; GUI #
include win64a.inc
ID_TXT		equ 100
ID_SEND_TXT	equ 101
ID_SEND_ICO	equ 102
ID_SEND_WAV	equ 103
IDC_DIALOG	equ 200
IDC_ICON1	equ 500
IDC_IMG1 	equ 104
RPC_S_OK	equ 0
RPC_C_LISTEN_MAX_CALLS_DEFAULT equ 1234

RPC_VERSION  struc
	MajorVersion dw ?
	MinorLinker  dw ?
RPC_VERSION  ends

RPC_CLIENT_INTERFACE struct
	Len		dd ?
	InterfaceId	GUID <>
	a		RPC_VERSION <>
	TransferSyntax	GUID <>
	b		RPC_VERSION <>
			dd ?
	DispatchTable	dq ?
	RpcProtseqEndpointCount  dd ?,?
	RpcProtseqEndpoint dq ?
	DefaultManagerEpv dq ?
	InterpreterInfo dq ?
	Flags		dd ?,?
RPC_CLIENT_INTERFACE ends
.code
WinMain proc 
	enter	30h,0
	mov	r9d,256;cx
	mov	[rbp-10h],r9
	mov	qword ptr [rbp-8],LR_DEFAULTCOLOR
	invoke	LoadImageA,IMAGE_BASE,IDC_ICON1,IMAGE_ICON;,256,256,LR_DEFAULTCOLOR
	mov	r9d,offset DialogProc
	mov	qword ptr[rbp-10h],rax;30h-10h=+20h
	invoke	DialogBoxParamA,IMAGE_BASE,IDC_DIALOG,HWND_DESKTOP
	invoke	RtlExitUserProcess,NULL
WinMain endp

DialogProc proc hWnddlg:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	hResource:qword
local	pResource:qword
local	FSize:qword
local	hFile:dword
local	szReadWrite:qword	;number of bytes actually read or write
local	stringBinding:qword

	mov	hWnddlg,rcx
	mov	lParam,r9

	cmp	edx,WM_INITDIALOG
        je	wmINITDIALOG
	cmp	edx,WM_CLOSE
	je	wmCLOSE
	cmp	edx,WM_COMMAND
	je	wmCOMMAND
	cmp	edx,WM_DESTROY
	je	wmDESTROY
	xor	eax,eax
	jmp	exit0
wmDESTROY:
	jmp	wmBYE
wmSEND_WAV:mov	ecx,offset wav_file
	invoke	CreateFile,,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,\
        FILE_ATTRIBUTE_ARCHIVE,0
        mov	hFile,eax
        invoke	GetFileSize,eax,0
	mov	FSize,rax
	invoke	GlobalAlloc,GPTR,eax
	mov	p,rax
	lea	r9d,szReadWrite
	and	qword ptr[rsp+20h],0
        invoke	ReadFile,hFile,eax,FSize
        invoke	CloseHandle,hFile
	invoke	RPC_SampleInterface_sampleFunc,bindingHandle,FSize,p
	jmp	wmBYE
wmSEND_ICO:mov	edx,p1
	invoke	FindResource,0,,RT_ICON; find the resource
	mov	hResource,rax
	invoke  SizeofResource,0,eax		; get its size
	mov	FSize,rax
	inc	eax
	invoke	GlobalAlloc,GPTR,eax
	mov	p,rax
	mov	edi,eax
	invoke	LoadResource,0,hResource	; load the resource
	invoke	LockResource,eax;pResource
	mov	esi,eax
	mov	byte ptr[rdi],CF_BITMAP
	inc	edi
	mov	rcx,FSize
	rep	movsb
	mov	rdx,FSize
	inc	edx
	invoke	RPC_SampleInterface_sampleFunc,bindingHandle,,p
	mov	ecx,256
	and	qword ptr[rsp+30h],LR_DEFAULTCOLOR;LR_DEFAULTCOLOR=0
	mov	[rsp+20h],rcx
	mov	[rsp+28h],rcx
	mov	rcx,p
	inc	ecx
	invoke  CreateIconFromResourceEx,,FSize,TRUE,30000h;270376,TRUE,30000h
	mov	[rsp+20h],rax
	invoke  SendDlgItemMessageA,hWnd,IDC_IMG1,STM_SETIMAGE,IMAGE_ICON
	xor	p1,11b
	jmp	wmBYE
wmSEND_TXT:invoke GlobalAlloc,GPTR,256
	mov	p,rax
	mov	byte ptr[rax],CF_TEXT
	inc	eax
	invoke  GetDlgItemTextA,hWnddlg,ID_TXT,eax,256
	inc	eax
	invoke	RPC_SampleInterface_sampleFunc,bindingHandle,eax,p
	jmp	wmBYE
wmINITDIALOG:mov hWnd,rcx
        invoke	GetProcessHeap
	mov     hHeap,rax
	invoke	GetDlgItem,hWnddlg,IDC_IMG1
	invoke	SendMessageA,eax,STM_SETIMAGE,IMAGE_ICON,lParam
;setup Rpc-----------------------------
	lea	ecx,stringBinding
	mov	[rsp+28h],rcx
	movr	qword ptr[rsp+20h],security
	mov	r9d,offset endpoint
	mov	edx,offset protocol
	invoke	RpcStringBindingComposeA,0,,0
	or	eax,eax;eax=RPC_S_OK?
	jne	wmBYE
	mov	edx,offset bindingHandle
	invoke	RpcBindingFromStringBindingA,stringBinding
        invoke	RpcStringFreeW,&stringBinding
	or	eax,eax;eax=RPC_S_OK?
	jne	wmBYE
;----------------------------------------------------
	cmp	bindingHandle,0
	jnz	wmBYE
	mov	r8d,offset szWin
	mov	ecx,offset Error
	invoke	MessageBoxA,hWnd,,,MB_OK
	jmp	wmBYE
wmCOMMAND:cmp	r8d,BN_CLICKED shl 16 + ID_SEND_TXT
        je      wmSEND_TXT
        cmp	r8d,BN_CLICKED shl 16 + ID_SEND_WAV
        je      wmSEND_WAV
        cmp	r8d,BN_CLICKED shl 16 + ID_SEND_ICO
	je      wmSEND_ICO
	cmp     r8d,BN_CLICKED shl 16 + IDCANCEL
        jne     wmBYE
wmCLOSE:invoke	EndDialog,,0
	mov	ecx,offset bindingHandle
	invoke	RpcBindingFree
wmBYE:	mov	eax,TRUE
exit0:	leave
	retn
DialogProc endp
RPC_SampleInterface_sampleFunc proc bindingHandle:qword,bufferLength:dword,buffer:qword

		mov	[rsp+20h],r8;buffer
		mov	r9d,edx;bufferLength
		mov	r8,rcx;bindingHandle
		lea	rdx, RPC_SampleInterface__MIDL_ProcFormatString
		lea	rcx,RPC_SampleInterface_StubDesc ; pStubDescriptor
		invoke	NdrClientCall2
		leave
		retn
RPC_SampleInterface_sampleFunc endp

MIDL_user_allocate proc len:qword
	mov	r8d,ecx
	invoke	RtlAllocateHeap,hHeap,0
	leave
	ret
MIDL_user_allocate endp
MIDL_user_free proc lpMem:qword
	mov	r8d,ecx
	invoke	HeapFree,hHeap,0
	leave
	ret
MIDL_user_free endp
;---------------------------------------
.data
szWin		db 'Remote Procedure Call Reciever',0
Error		db "Unable to setup an RPC connection, exiting...",0
bindingHandle	dq ?
hWnd		dq ?
protocol	db "ncalrpc",0
endpoint	db "{46E785FC-BCCC-46B8-B161-D6C90D391670}",0; // Unique user-defined endpoint ID in a free form
security	db "Security=impersonation static false",0
p	dq ?
p1      dd 1
RPC_SampleInterface__MIDL_ProcFormatString:
	db 0
	db 48h	; H
	dd 0
	dw 0
	dw 18h
	db 32h,	0
	dw 0
	dw 8
	dw 0
	db 42h,2,10,5
	dw 0
	dw 1
	dw 0
	dw 0
	dw 48h
	dw 8
	db 8, 0
	dw 10Bh
	dw 10h
	dw 6
	db 0
RPC_SampleInterface_StubDesc:
	dq RPC_SampleInterface___RpcClientInterface; RpcInterfaceInformation
	dq MIDL_user_allocate;	pfnAllocate
	dq MIDL_user_free; pfnFree
	dq RPC_SampleInterface__MIDL_AutoBindHandle; IMPLICIT_HANDLE_INFO.pAutoHandle
	dq 0			; apfnNdrRundownRoutines
	dq 0			; aGenericBindingRoutinePairs
	dq 0			; apfnExprEval
	dq 0			; aXmitQuintuple
	dq RPC_SampleInterface__MIDL_TypeFormatString; pFormatTypes
	dd 1			; fCheckBounds
	dd 50002h		; Version
	dq 0			; pMallocFreeStruct
	dd 8010274h		; MIDLVersion
	db 4 dup(0)
	dq 0			; CommFaultOffsets
	dq 0			; aUserMarshalQuadruple
	dq 0			; NotifyRoutineTable
	dq 1			; mFlags
	dq 0			; CsRoutineTables
	dq 0			; ProxyServerInfo
	dq 0			; pExprInfo
RPC_SampleInterface___RpcClientInterface label RPC_CLIENT_INTERFACE
	dd sizeof RPC_CLIENT_INTERFACE;dd Length sizeof RPC_CLIENT_INTERFACE;+0
	GUID <8A4A7813h,0ADAAh,49BCh,{99h,6Ah,4Dh,47h,71h,5Fh,0CAh,40h}>
	RPC_VERSION <1,0>
	GUID <8A885D04h,1CEBh,11C9h,{9Fh,0E8h,8,0,2Bh,10h,48h,60h}>
	RPC_VERSION <2,0>
	dd 0;+2C
	dq 0;  PRPC_DISPATCH_TABLE   DispatchTable;+30h
	dd 0,0;  unsigned int          RpcProtseqEndpointCount;+38h
	dq 0;  PRPC_PROTSEQ_ENDPOINT RpcProtseqEndpoint;+40h
	dq 0;  ULONG_PTR             Reserved;+48h
	dq 0;  void const            *InterpreterInfo;+50h
	dq 0;+58h
	dd 0;unsigned int          Flags;+5Ch
RPC_SampleInterface__MIDL_AutoBindHandle dq 0,0
RPC_SampleInterface__MIDL_TypeFormatString:
	dw 0
	db 11h,0
	dw 2
	db 1Bh,0
	dw 1
	db 29h,0
	dw 8
	dw 1
	db 2,5Bh,0
;-------------------------------
hHeap	dq ?
wav_file db '..\Images\03.wav',0
end